#ifndef ACTOR_H
#define ACTOR_H

#include <memory>
#include <SDL3/SDL_rect.h>

class Actor : public std::enable_shared_from_this<Actor>
{
public:
    virtual ~Actor() {};
    //virtual void Update(float deltaTime) {};
    void SetPosition(float x, float y);
    void MoveBy(float x, float y);
    SDL_FRect GetHitbox(){return m_Hitbox;}

    friend class ActorFactory;
protected:
    virtual void Init() {};
    Actor(SDL_FRect hitbox) : m_Hitbox(hitbox) {};
    SDL_FRect m_Hitbox;
};

#endif // ACTOR_H
